//-----------------------------------------------------------------
// CONFIGURAES URL E PATHS
//-----------------------------------------------------------------
var Dados = {
    BASE_URL :"http://"+window.location.hostname+"/postador/",
    IMG_URL :"http://"+window.location.hostname+"/postador/img/"
};

$.fn.extend({
    serializeUni: function() {
		return jQuery.param( this.serializeArrayUni() );
	},

	serializeArrayUni: function() {
        var rselectTextarea = /select|textarea/i;
        var rinput = /text|hidden|password|search/i;
        var rCRLF = /\r?\n/g;
		return this.map(function(){
			return this.elements ? jQuery.makeArray( this.elements ) : this;
		})
		.filter(function(){
			return this.name && !this.disabled &&
				( this.checked || rselectTextarea.test( this.nodeName ) ||
					rinput.test( this.type ) );
		})
		.map(function( i, elem ){
			var val = $(this).uni2ent(jQuery( this ).val());

			return val == null ?
				null :
				jQuery.isArray( val ) ?
					jQuery.map( val, function( val, i ){
						return { name: elem.name, value: val.replace( rCRLF, "\r\n" ) };
					}) :
					{ name: elem.name, value: val.replace( rCRLF, "\r\n" ) };
		}).get();
	},
    uni2ent: function (srcTxt) {
        var entTxt = '';
        var c, hi, lo;
        var len = 0;
        for (var i=0, code; code=srcTxt.charCodeAt(i); i++) {
            var rawChar = srcTxt.charAt(i);
            // needs to be an HTML entity
            if (code > 255) {
                // normally we encounter the High surrogate first
                if (0xD800 <= code && code <= 0xDBFF) {
                    hi  = code;
                    lo = srcTxt.charCodeAt(i+1);
                    // the next line will bend your mind a bit
                    code = ((hi - 0xD800) * 0x400) + (lo - 0xDC00) + 0x10000;
                    i++; // we already got low surrogate, so don't grab it again
                }
                // what happens if we get the low surrogate first?
                else if (0xDC00 <= code && code <= 0xDFFF) {
                    hi  = srcTxt.charCodeAt(i-1);
                    lo = code;
                    code = ((hi - 0xD800) * 0x400) + (lo - 0xDC00) + 0x10000;
                }
                // wrap it up as Hex entity
                c = "&#x" + code.toString(16).toUpperCase() + ";";
            } else {
                c = rawChar;
            }
            entTxt += c;
            len++;
        }
        return entTxt;
    }
});

var mndti = {
    get_post : function(par){
        // SE DADOS TIPO POST, SERIALIZA CAMPOS
        if(par['type'] == 'POST' && par['elf']){ var dataString = $(par['elf']).serializeUni(); }
        
        $.ajax({
            url: Dados.BASE_URL+'cont/ajax.php?querys='+par['querys'],
            dataType: par['dataType'],
            type: par['type'],
            cache: par['cache'],
            data: dataString,
            success: function(data, textStatus){
                // LOADING REMOVE
                mndti.loading_remove();
                // INNER APPEND
                if(par['inner'] == 'append'){ $(par['elr']).append(data); }
                // INNER HTML - PADRAO
                if(par['inner'] == 'html') { $(par['elr']).html(data); }
                
                if(par['inner'] == 'uipop') { mndti.uipop(par, data); }
            },
        });
    },
    uipop : function (par,html){
        
        $('body').after('<div id="'+par['elui'].substring(1)+'"></div>');
        $(par['elui']).html(html);
        
        if(par['uititle']){ par['jtitle'] = par['jtitle']+' ('+par['elui']+')'; }
                
        $(par['elui']).dialog({
            modal: par['uimodal'],
            title : par['jtitle'],
            width: 'auto',
            height: 'auto',
            resizable: false,
            draggable: par['uidraggable'],
            close: function(ev, ui) { $(this).dialog('destroy').remove(); }

        });
    },
    
    click : function (par){
        $('body').on('click', par['el'], function(e){
            // PREVENT ACAO PADRAO
            e.preventDefault();
            par['obj'] = this;
            // PUXA O QUERYSTRING
            par['querys'] = $(this).attr("data-mndti-querys");
            
            // ELEMENTO DE RETORNO
            var dataELR = $(this).attr("data-mndti-elr"); 
            if(dataELR){ par['elr'] = dataELR; } else { par['elr'] = par['elr']; }
            
            // REQUEST GET
            if(par['type'] == 'GET'){
                if(par['inner'] == 'uipop'){
                    par['elui'] = $(this).attr("data-mndti-elui");                    
                    par['jtitle'] = $(this).attr("title");
                    var uiinstanceQ = $(par['elui']).length;
                    if(uiinstanceQ == 0){
                        mndti.loading();
                        mndti.get_post(par);
                    } else {
                        alert('ATENCAO: ja existe uma janela semelhante aberta, voce deve fecha-la antes de abrir uma nova. JANELA: '+par['elui']);
                    }
                } else {
                    mndti.loading();
                    mndti.get_post(par);
                }
            }
            
            // REQUEST POST
            if(par['type'] == 'POST'){
                // ELEMENTO DO FOMULARIO PARA SERIALIZE
                var dataELF = $(this).attr("data-mndti-elf");
                if(dataELF){ par['elf'] = dataELF; } else { par['elf'] = par['elf']; }
                
                mndti.loading();
                mndti.get_post(par);
            }
        });
    },
    teste: function(obj){
        return AutoValidar.valida(obj);        
    },
    remove_elemento : function (el,tag){
        $('body').on('click', el, function(e) {
            e.preventDefault();
            //var el2 = $(this).attr('data-act');
            $(this).parents(tag).empty().hide();
            //$(el2).empty();
        });
    },    
    adicionar_elemento : function(el,el2,tag,html){
        $('body').on('click', el, function(e) {
            e.preventDefault();
            //var i = $(el2+'>'+el3).length+1;               
            $(el2).append('<'+tag+'>'+html+'</'+tag+'>');
            exe.afterFNL();
        });
    },
    
    loading : function(){
        $('body').after('<div id="loading"><div id="ajax_loading"><img src="'+Dados.IMG_URL+'ajax_loading.gif" alt="carregando" /></div></div>');        
    },
    loading_remove : function(){
        $('#loading').remove();
    },
    portal_cats : function(par){
        $(par['el']).on('change', function(){
            // LOADING
            mndti.loading();
            // QUERYSTRING
            par['querys'] = 'cat:portal-select:'+this.value+'-'+$(this ).attr("data-mndti-querys");
            // ELEMENTO DE RETORNO
            var dataELR = $(this).attr("data-mndti-elr"); 
            if(dataELR){ par['elr'] = dataELR; } else { par['elr'] = par['elr']; }
            mndti.get_post(par);
        });
    },
    
    load : function(options){
        var defaults = { inner: 'html', type: 'GET', dataType: 'html', act: 'click', uimodal: false, uititle: true, uidraggable: true, cache: false };        
        var par = $.extend({}, defaults, options);
        
        if(par['act'] == 'onchange'){
            mndti.portal_cats(par);
        }
        if(par['act'] == 'click'){
            mndti.click(par);
        }
    },
    
    
    // EXECUTAR TODAS FUNCOES
    all : function (){
        mndti.load({act: 'onchange', el: '[rel=categoria_ajax]'});
        mndti.load({act: 'click', el:'.cat-gerenciar-inf', inner: 'uipop'});
        mndti.load({ el: '.salvar_dados_categoria', type: 'POST' });
        mndti.adicionar_elemento('.adicionar_op_categoria','#adicionar_op_categoria','p','<input name="dados_categ[]" type="text" value="" /><a href="" class="remove_op_categoria" title="remover este campo">[x]</a>');
        mndti.adicionar_elemento('.adicionar_portal_g','#adicionar_op_categoria','p','<input class="f-portal-id" name="f_portal_id[]" value="" /><input class="f-portal-nome" name="f_portal_nome[]" value="" /><input class="f-portal-uid" name="f_portal_uid[]" value="" class="f-portal-uid" /><a href="" class="remove_op_categoria" title="remover este campo">[x]</a>');
        mndti.remove_elemento('.remove_op_categoria', 'p');
        
        
    },
}

// JQUERY LOADING
$(document).ready(function() { mndti.all(); });